Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

- Main Page
- Namespaces
- Classes
- Files
- Related Pages
- Examples

- Class List
- Class Hierarchy
- Class Members

# openvrml::mfnode Class Reference

`#include <openvrml/field_value.h>`

Inheritance diagram for openvrml::mfnode:

[legend]

List of all members.

## Detailed Description

A node reference array node field value.

Model of
  Field Value

## Public Types

typedef std::vector < boost::intrusive_ptr< node > > | value_type
| Type of value.

## Public Member Functions

| mfnode (value_type::size_type n=0, const value_type::value_type &value=value_type::value_type()) throw ( std::bad_alloc )
| Construct.
| mfnode (const value_type &value) throw ( std::bad_alloc )
| Construct.
| mfnode (const mfnode &mfn)
| Construct a copy.
virtual | ~mfnode () throw ()
| Destroy.
mfnode & | operator= (const mfnode &mfn) throw ( std::bad_alloc )
| Assign.
const value_type & | value () const throw ()
| Access.
void | value (const value_type &val) throw ( std::bad_alloc )
| Mutate.
void | swap (mfnode &mfn) throw ()
| Swap.

## Static Public Attributes

static const type_id | field_value_type_id = mfnode_id
| `field_value::type_id` for this class.

## Private Member Functions

virtual std::auto_ptr < field_value > | do_clone () const throw ( std::bad_alloc )
| Polymorphically construct a copy.
virtual mfnode & | do_assign (const field_value &value) throw ( std::bad_cast , std::bad_alloc )
| Virtual assignment.
virtual type_id | do_type () const throw ()
| Get the `field_value::type_id` associated with this class.
virtual void | print (std::ostream &) const
| Print to an output stream.

## Related Functions

(Note that these are not member functions.)
bool | operator== (const mfnode &lhs, const mfnode &rhs) throw()
| Compare for equality.
bool | operator!= (const mfnode &lhs, const mfnode &rhs) throw()
| Compare for inequality.
template<> void | swap (openvrml::mfnode &a, openvrml::mfnode &b)
| Swap the values of `a` and `b`.

## Member Typedef Documentation

openvrml::mfnode::value_type

Type of value.

## Constructor & Destructor Documentation

openvrml::mfnode::mfnode | ( | value_type::size_type | n = `0`,
|  | const value_type::value_type & | value = `value_type::value_type()` |
| ) |  |  | throw ( std::bad_alloc )`[explicit]`

Construct.

Creates an `mfnode` with `n` copies of `value`.

Parameters:

  `[in]` | n | the number elements in the `mfnode`.
  `[in]` | value | used to initialize the `mfnode`.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

Postcondition:
  size is `n`. Every element is a copy of `value`.

openvrml::mfnode::mfnode | ( | const value_type & | value | ) | throw ( std::bad_alloc )`[inline, explicit]`

Construct.

Parameters:

  `[in]` | value | initial value.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

openvrml::mfnode::mfnode | ( | const mfnode & | mfn | ) |

Construct a copy.

Parameters:

  `[in]` | mfn | the instance to copy.

openvrml::mfnode::~mfnode | ( |  | ) | throw ()`[virtual]`

Destroy.

Each of the `mfnode`'s value elements is destroyed, and memory allocated for them (if any) is deallocated.

## Member Function Documentation

openvrml::mfnode & openvrml::mfnode::operator= | ( | const mfnode & | mfn | ) | throw ( std::bad_alloc )

Assign.

Parameters:

  `[in]` | mfn | the value to assign.

Returns:
  a reference to the instance.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

const openvrml::mfnode::value_type & openvrml::mfnode::value | ( |  | ) | const throw ()

Access.

Returns:
  the node pointers.

Reimplemented from openvrml::field_value.

void openvrml::mfnode::value | ( | const value_type & | val | ) | throw ( std::bad_alloc )

Mutate.

Parameters:

  `[in]` | val | the new value.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

void openvrml::mfnode::swap | ( | mfnode & | mfn | ) | throw ()

Swap.

Parameters:

  `[in,out]` | mfn | the value to swap with this one.

std::auto_ptr< openvrml::field_value > openvrml::mfnode::do_clone | ( |  | ) | const throw ( std::bad_alloc )`[private, virtual]`

Polymorphically construct a copy.

Returns:
  a pointer to a copy of the object.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

Implements openvrml::field_value.

openvrml::mfnode & openvrml::mfnode::do_assign | ( | const field_value & | value | ) | throw ( std::bad_cast , std::bad_alloc )`[private, virtual]`

Virtual assignment.

Returns:
  a reference to the object.

Exceptions:

  | std::bad_cast | if `value` is not an mfnode object.
  | std::bad_alloc | if memory allocation fails.

Implements openvrml::field_value.

openvrml::field_value::type_id openvrml::mfnode::do_type | ( |  | ) | const throw ()`[private, virtual]`

Get the `field_value::type_id` associated with this class.

Returns:
  `field_value::mfnode_id`.

Implements openvrml::field_value.

void openvrml::mfnode::print | ( | std::ostream & | out | ) | const`[private, virtual]`

Print to an output stream.

Any null elements in the mfnode will not get printed; VRML97 syntax does not accommodate NULL in an mfnode.

Parameters:

  `[in,out]` | out | an output stream.

Implements openvrml::field_value.

## Friends And Related Function Documentation

bool operator== | ( | const mfnode & | lhs,
|  | const mfnode & | rhs |
| ) |  |  | throw()`[related]`

Compare for equality.

Parameters:

  `[in]` | lhs | left-hand operand.
  `[in]` | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` have the same value; `false` otherwise.

bool operator!= | ( | const mfnode & | lhs,
|  | const mfnode & | rhs |
| ) |  |  | throw()`[related]`

Compare for inequality.

Parameters:

  `[in]` | lhs | left-hand operand.
  `[in]` | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` do not have the same value; `false` otherwise.

template<> void swap | ( | openvrml::mfnode & | a,
|  | openvrml::mfnode & | b |
| ) |  |  | `[related]`

Swap the values of `a` and `b`.

Does not throw.

Parameters:

  `[in,out]` | a |
  `[in,out]` | b |

## Member Data Documentation

const openvrml::field_value::type_id openvrml::mfnode::field_value_type_id = mfnode_id`[static]`

`field_value::type_id` for this class.